# -------------------------------------------------------------------------------------------------
#<profile4xi profile = "12"/>
#<program4xi program = "pickle4xi.py">
#<abstract4xi abstract = "offers services for pickling"/>
#<refer4xi reference = "test*4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'pickle4xi', 'sense_pickle4xi', 'reason_pickle4xi', 'ace_pickle4xi', 'xml_pickle4xi', 'Pickle4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    from time import localtime, strftime             
except:
    pass
try:                 # rare ones
    import copyreg
    from cPickle import PicklingError          
except:
    from pickle import PicklingError
       
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = " 
from forkingpickler4xi import ForkingPickler4Xi 
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi 
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi 
from pickle2z4xi import Pickle2z4Xi 
from pickle2_4xi import Pickle2_4Xi
from print4xi import print4xi
from rebuild_as_list4xi import rebuild_as_list4xi
from time4xi import time4xi
#"
#/>
# -------------------------------------------------------------------------------------------------
# DragonXi Globals                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global PickleKB4Xi
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "pickle4xi" usage = "
#    pickling
#">                              
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def pickle4xi(self):
    '''
    pickling
    '''
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 1/5)
    # ---------------------------------------------------------------------------------------------     
    
    class2print = "pickle4xi"
    method2print = "pickle4xi"

    message2print = "{(Step 1/5a) started" + "; pickle4xi-started: " + str(pickle4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        

    view_types2xi = [type(getattr({}, name)()) for name in ('items','keys','values')]

    message2print = "{(Step 1/5b) set" + "; view_types2xi-set-by-pickle4xi to: " + str(view_types2xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
            
        
    if view_types2xi[0] is not list:       # only needed in Py3.0
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
          
        
        for view_type2xi in view_types2xi:
    
            # -------------------------------------------------------------------------------------    
            # (Step 2/5)
            # -------------------------------------------------------------------------------------     
             
            message2print = "{(Step 2/5a) passing" + "; view-type2xi-passing-to-ForkingPickler4Xi-register-by-pickle4xi: " + str(view_type2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
        
            message2print = "{(Step 2/5b) passing" + "; rebuild-as-list4xi-passing-to-ForkingPickler4Xi-register-by-pickle4xi: " + str(rebuild_as_list4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                   
    
            # -------------------------------------------------------------------------------------    
            # (Step 3/5)
            # -------------------------------------------------------------------------------------     
                           
            ForkingPickler4Xi.register(view_type2xi, rebuild_as_list4xi)
    
                   
            message2print = "{(Step 3/5) performed" + "; ForkingPickler4Xi-register-performed-by-pickle4xi: " + str(ForkingPickler4Xi.register) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
    
            # -------------------------------------------------------------------------------------    
            # (Step 4/5)
            # -------------------------------------------------------------------------------------     
                       
            message2print = "{(Step 4/5a) passing" + "; view-type2xi-passing-to-copyreg-pickle-by-pickle4xi: " + str(view_type2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
        
            message2print = "{(Step 4/5b) passing" + "; rebuild-as-list4xi-passing-to-copyreg-pickle-by-pickle4xi: " + str(rebuild_as_list4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
                       
            try:
                copyreg.pickle(view_type2xi, rebuild_as_list4xi)
            
                message2print = "{(Step 4/5c) performed" + "; copyreg-pickle-performed-by-pickle4xi: " + str(copyreg.pickle) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
            except:
                    
                message2print = "{(Step 4/5d) yielded" + "; view-type2xi-yielded-by-pickle4xi: " + " *** " + str(view_type2xi)  + " *** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                 
    
    # ---------------------------------------------------------------------------------------------    
    # (Step 5/5)
    # ---------------------------------------------------------------------------------------------     
   
    message2print = "{(Step 5/5) returning" + "; pickle4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
            
               
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "sense_pickle4xi" usage = "senses pickle knowledgebase">
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def sense_pickle4xi():
    '''
    sense_pickle4xi senses pickle knowledgebase
    '''
    global PickleKB4Xi
    
    # -----------------------------------------------------------------------------------------
    # initialize knowledge
    # -----------------------------------------------------------------------------------------      
    kb2v = PickleKB4Xi
    keys2alpha = PickleKB4Xi.keys()                                    
    
    kb2xi = {('d', 'dragonized'): 'dragonized', ('d', 'dragonizing'): 'dragonizing'} 
    
    for key2alpha in sorted(keys2alpha):                             #  
        print("key2alpha :" ,key2alpha)                              # key2alpha : z 
        
        keys2pickle = PickleKB4Xi[key2alpha].keys()                      # 
        
        print("keys2pickle :", keys2pickle)                              # keys2pickle : dict_keys(['zeroing', 'zeroed'])
        
        for key2pickle in sorted(keys2pickle):                            
            
            print("key2pickle :", key2pickle)                            # key2pickle : zeroed, key2pickle : zeroing
            
            kb2xi[key2alpha, key2pickle] = key2pickle                                
    
            print("kb2xi[", key2alpha, "," , key2pickle , "] = ", key2pickle)  # kb2xi[ z , zeroed ] =  zeroed, kb2xi[ z , zeroing ] =  zeroing ....
            
    # -----------------------------------------------------------------------------------------
    # sense knowledge
    # -----------------------------------------------------------------------------------------        
    
    
    # -----------------------------------------------------------------------------------------
    # return knowledge
    # -----------------------------------------------------------------------------------------        
    print("sense_pickle4xi returning kb2xi: ", kb2xi)                  # {('s', 'skipped'): 'skipped', ('v', 'ventured'): 'ventured', ('l', 'looped'): 'looped',.....
    return kb2xi                                                     # not in alphabetical order
#</function4xi>
            
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reason_pickle4xi" usage = "reasons pickle knowledgebase">
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

def reason_pickle4xi():
    '''
    reason_pickle4xi reasons pickle knowledgebase
    '''
    global PickleKB4Xi        
    
    # -----------------------------------------------------------------------------------------
    # initialize knowledge
    # -----------------------------------------------------------------------------------------         
    kb4xi = {'dragonized': 'dragonized', 'dragonizing': 'dragonizing'}
    
    kb4v = PickleKB4Xi
    print("reason input kb4v: ", kb4v)                               # 
                                                                     # 'a': {'acknowledging': 'acknowledging',...
    
    keys4alpha = PickleKB4Xi.keys()      
   
    
    # -----------------------------------------------------------------------------------------
    # reason knowledge
    # -----------------------------------------------------------------------------------------          
    for key4alpha in sorted(keys4alpha):                             # _, a, b, c ........ 
        print("key4alpha :" ,key4alpha)                              # key4alpha : z
        
        dict4xi = PickleKB4Xi[key4alpha]                     
        
        print("dict4xi :", dict4xi)                                  # dict4xi : {'zeroing': 'zeroing', 'zeroed': 'zeroed'}
        
        pickles4xi = dict4xi.keys()
        print("pickles4xi : ", pickles4xi)                           # pickles4xi :  dict_keys(['zeroing', 'zeroed'])
        
        for key4pickle in sorted(pickles4xi):                            
            
            print("key4pickle :", key4pickle)                        # key4pickle : zeroed, key4pickle : zeroing
            
            kb4xi[key4pickle] = key4pickle                             
    
            print("kb4xi[", key4pickle, "] = " , key4pickle)         # kb4xi[ zeroed ] =  zeroed, kb4xi[ zeroing ] =  zeroing
              
    # -----------------------------------------------------------------------------------------
    # return knowledge
    # -----------------------------------------------------------------------------------------        
    print("reason returning kb4xi: ", kb4xi)                         # {'looped': 'looped', 'rounded': 'rounded', 'freeing': 'freeing', 'polled': 'polled' ....
    return kb4xi
    
#</function4xi>
  
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "ace_pickle4xi" usage = "aces pickle knowledgebase">
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

def ace_pickle4xi():
    '''
    pickle4xi aces pickle knowledgebase
    '''
   
    
    # -----------------------------------------------------------------------------------------
    # initialize knowledge
    # -----------------------------------------------------------------------------------------        
    kb8xi = reason_pickle4xi()
 
    
  
             
    
    return kb8xi
    
    # -----------------------------------------------------------------------------------------
    #
    # -----------------------------------------------------------------------------------------
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "xml_pickle4xi" usage = "converts pickles to xml">
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
      
 
def xml_pickle4xi (context_param = 
    {'file_path4xi': '..\\..\\xml\\reason-pickle4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning Pickles of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Pickles</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Available pickles.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ReasonDragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Pickles for actions.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}):
    
    
    '''
    xml_pickle4xi creates XML file from pickles knowledgebase
    
    '''       
    
   
    c2xi = context_param
    
    keys2context = c2xi.keys()
    
    # ---------------------------------------------------------------------------------------------
    # tailor 
    # ---------------------------------------------------------------------------------------------     
    if 'debug4xi' in keys2context:
        debug2xi = c2xi['debug4xi']     
    else:
        debug2xi = False
    # ---------------------------------------------------------------------------------------------
    # end of tailoring 
    # ---------------------------------------------------------------------------------------------     
 
    
    # ---------------------------------------------------------------------------------------------
    # REASON
    # --------------------------------------------------------------------------------------------- 
    
    if debug2xi is True:
        print(33*("="))
        print("xml_pickle4xi: REASONING")
        print(33*("="))
        print("")
        print("xml_pickle4xi: set c2xi to: ", c2xi)
        print("")
                    
    reasonKB4Xi = reason_pickle4xi()       
   
    
    len2kb= len(reasonKB4Xi)
    keys2kb = reasonKB4Xi.keys()            
    pickle2xi = 'dragonized'
                                            
    if debug2xi is True:
        print(33*("-"))
        print("xml_pickle4xi: Input from reason_pickle4xi:", reasonKB4Xi)  # {'looped': 'looped', 'rounded': 'rounded', 'freeing': 'freeing',
        print(33*("-"))
                                                       

 
  
    # ---------------------------------------------------------------------------------------------
    # tailor 
    # ---------------------------------------------------------------------------------------------       
    #f2xi=open('..\\..\\xml\\reason-default4xi.xml', 'w')
    if 'file_path4xi' in keys2context:
        filepath2xi = c2xi['file_path4xi']
    else:
        filepath2xi = '..\\..\\xml\\reason-pickle4xi.xml'
    f2xi=open(filepath2xi, 'w')
    # ---------------------------------------------------------------------------------------------
    # end of tailoring 
    # --------------------------------------------------------------------------------------------- 

   
    if debug2xi is True:
        print(33*("="))
        print("xml_pickle4xi: opened XML file: ", filepath2xi)          
        print(33*("="))
        
        print(33*("-"))
        print("xml_pickle4xi: create header for XML file")     
        print(33*("-"))    
                
    f2xi.write('<?xml version="1.0"?>\n')
    f2xi.write('<rdf:RDF\n')
    f2xi.write('   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"\n')
    f2xi.write('   xmlns:xsd="http://www.w3.org/2001/XMLSchema#"\n')
    f2xi.write('   xmlns:owl="http://www.w3.org/2002/07/owl#"\n')
    f2xi.write('   xmlns:rdfs="http://www.w3.org/2000/01/rdf-schema#"\n')
    
    # ---------------------------------------------------------------------------------------------
    # tailor  
    # ---------------------------------------------------------------------------------------------     
    #f2xi.write('   xmlns="http://www.yourdragonxi.org/web/lib/owl/DefaultReason4Xi.owl#"\n')
    if 'name_space4xi' in keys2context:
        namespace2xi = c2xi['name_space4xi'] 
    else:
        namespace2xi = '   xmlns="http://www.yourdragonxi.org/web/lib/owl/PickleReason4Xi.owl#"\n'     
    f2xi.write(namespace2xi)
    # ---------------------------------------------------------------------------------------------
    # end of tailoring  
    # --------------------------------------------------------------------------------------------- 
        
    f2xi.write('   xmlns:p1="http://www.owl-ontologies.com/assert.owl#"\n')
    
    # ---------------------------------------------------------------------------------------------
    # tailor  
    # ---------------------------------------------------------------------------------------------     
    #f2xi.write('   xml:base="http://www.yourdragonxi.org.com/web/lib/owl/reason-default4xi.owl">\n')
    if 'xml_base4xi' in keys2context: 
        xmlbase2xi = c2xi['xml_base4xi'] 
    else:
        xmlbase2xi = '   xml:base="http://www.yourdragonxi.org.com/web/lib/owl/reason-pickle4xi.owl">\n'
    f2xi.write(xmlbase2xi)
    # ---------------------------------------------------------------------------------------------
    # end of tailoring  
    # --------------------------------------------------------------------------------------------- 
    
    # ---------------------------------------------------------------------------------------------
    # tailor  
    # ---------------------------------------------------------------------------------------------             
    #f2xi.write('   <owl:Ontology rdf:about="DefaultReason4Xi">\n')
    if 'ontology_about4xi' in keys2context: 
        ontology_about2xi = c2xi['ontology_about4xi']
    else:
        ontology_about2xi = '   <owl:Ontology rdf:about="DefaultReason4Xi">\n'
    f2xi.write(ontology_about2xi)
    # ---------------------------------------------------------------------------------------------
    # end of tailoring  
    # --------------------------------------------------------------------------------------------- 
    
    # ---------------------------------------------------------------------------------------------
    # tailor  
    # ---------------------------------------------------------------------------------------------         
    #f2xi.write('      <rdfs:comment xml:lang="en">reason-default4xi</rdfs:comment>\n')
    if 'ontology_comment4xi' in keys2context:
        ontology_comment2xi = c2xi['ontology_comment4xi']
    else:
        ontology_comment2xi = '      <rdfs:comment xml:lang="en">reason-pickle4xi</rdfs:comment>\n'    
    f2xi.write(ontology_comment2xi)
    # ---------------------------------------------------------------------------------------------
    # end of tailoring  
    # --------------------------------------------------------------------------------------------- 
            
    f2xi.write('      <owl:versionInfo xml:lang="en">Version ' + strftime("%a, %d %b %Y %H:%M:%S",localtime()) + '</owl:versionInfo>\n')
    
    # ---------------------------------------------------------------------------------------------
    # tailor  
    # ---------------------------------------------------------------------------------------------        
    #f2xi.write('   <owl:Class rdf:ID="reasoned#0000000">\n')
    if 'class0_id4xi' in keys2context:    
        class2xi = c2xi['class0_id4xi']    
    else:
        class2xi = '   <owl:Class rdf:ID="reasoned#000000">\n'
    f2xi.write(class2xi)
    # ---------------------------------------------------------------------------------------------
    # end of tailoring  
    # ---------------------------------------------------------------------------------------------     
    
    
    # ---------------------------------------------------------------------------------------------
    # tailor  
    # ---------------------------------------------------------------------------------------------         
    #f2xi.write('      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n')
    if 'operation_comment4xi' in keys2context:
        operation_comment2xi = c2xi['operation_comment4xi']
    else:
        operation_comment2xi = '      <rdfs:comment xml:lang="en">Pickles</rdfs:comment>\n'
    f2xi.write(operation_comment2xi)
    # ---------------------------------------------------------------------------------------------
    # end of tailoring  
    # --------------------------------------------------------------------------------------------- 
            
    f2xi.write('   </owl:Class>\n')
    
    
    # ---------------------------------------------------------------------------------------------
    # tailor  
    # ---------------------------------------------------------------------------------------------     
    #f2xi.write('   <owl:ObjectProperty rdf:ID="reasoning#0">\n')
    if 'object_property_rdf4xi' in keys2context:
        object_property2xi = c2xi['object_property_rdf4xi']
    else:
        object_property2xi = '   <owl:ObjectProperty rdf:ID="reasoning#0">\n'
    f2xi.write(object_property2xi)
    # ---------------------------------------------------------------------------------------------
    # end of tailoring  
    # --------------------------------------------------------------------------------------------- 
    
    # ---------------------------------------------------------------------------------------------
    # tailor  
    # ---------------------------------------------------------------------------------------------         
    #f2xi.write('       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n')
    if 'object_property_comment4xi' in keys2context:
        object_property_comment2xi = c2xi['object_property_comment4xi']
    else:
        object_property_comment2xi = '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'    
    f2xi.write(object_property_comment2xi)
    # ---------------------------------------------------------------------------------------------
    # end of tailoring  
    # --------------------------------------------------------------------------------------------- 
        
    f2xi.write('   </owl:ObjectProperty>\n')
    
    orderIRI2xi = "#0"
    classIRI2xi = "to-be-solved-class"
    methodIRI2xi = "to-be-solved-method"
        
    classPropertyID2xi = 1
    classComment2xi = "Comment of Class "
    objectPropertID2Xi = 1
    objectPropertComment2xi = "Comment of Object Property "     
    
    
    #
    for key2kb in sorted(keys2kb):                                          # 'looped': 'looped', 'rounded': 'rounded', 'freeing': 'freeing'....
          

       
        f2xi.write('   <owl:Class rdf:ID="' + key2kb + '">\n')           # <owl:Class rdf:ID="added#900>

 
        
        f2xi.write('      <rdfs:comment xml:lang="en">' + reasonKB4Xi[key2kb] + '</rdfs:comment>\n') 
        
        f2xi.write('   </owl:Class>\n')
    
    if debug2xi is True:
        print(33*("-"))
        print("xml_pickle4xi: create end for XML file")     
        print(33*("-"))          
                
    f2xi.write('   </owl:Ontology>\n')
    f2xi.write('</rdf:RDF>\n')
    f2xi.write('<!-- Copyright Small & Smart Inc. All rights reserved. -->\n')

                  
    f2xi.close()        

    
    if debug2xi is True:
        print(33*("-"))
        print("xml_pickle4xi: closed XML file")     
        print(33*("-"))
                
#</function4xi>
    
              
# =================================================================================================
#<class4xi class = "Pickle4Xi" base = "object" child = "None" synopsis = "
#   Offers methods for pickle knowledgebase
#"
#>
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class Pickle4Xi(object):
    '''
    Pickle4Xi class offers methods for pickle knowledgebase
    '''
       
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi exposure = " 
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>
                                
      
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Pickle4Xi" usage = "initializes">
    # ---------------------------------------------------------------------------------------------
    def __init__(self, context2xi = {}):
        
        
        # -----------------------------------------------------------------------------------------
        # __init__                              
        # -----------------------------------------------------------------------------------------        
        
        class2print = 'Pickle4Xi'
        method2print = '__init__'
        
        
    #</methodize4xi> 
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-pickle-of-Pickle4Xi" usage = "senses">
    # ---------------------------------------------------------------------------------------------
    def sense_pickle(self):
        '''
        sense_picklei senses pickle knowledgebase
        '''
        
        # -----------------------------------------------------------------------------------------
        # return knowledge
        # -----------------------------------------------------------------------------------------        
        
        class2print = 'Pickle4Xi'
        method2print = 'sense_pickle'
            
        return sense_pickle4xi()
    #</methodize4xi> 
                    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-pickle-of-Pickle4Xi" usage = "reasons">
    # ---------------------------------------------------------------------------------------------
    def reason_pickle(self):
        '''
        reason_pickle reasons pickle knowledgebase
        '''
            
      
        # -----------------------------------------------------------------------------------------
        # return knowledge
        # -----------------------------------------------------------------------------------------        
        
        class2print = 'Pickle4Xi'
        method2print = 'reason_pickle'
            
        return reason_pickle4xi()
    #</methodize4xi> 
            
      
     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-pickle-of-Pickle4Xi" usage = "aces">
    # ---------------------------------------------------------------------------------------------
    def ace_pickle(self):
        '''
        ace_pickle aces pickle knowledgebase
        '''
       
        
        # -----------------------------------------------------------------------------------------
        # return knowledge
        # -----------------------------------------------------------------------------------------        
        
        class2print = 'Pickle4Xi'
        method2print = 'ace_pickle'
            
        return ace_pickle4xi()
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
    #</methodize4xi> 
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "xml-pickle-of-Pickle4Xi" usage = "xmls">
    # ---------------------------------------------------------------------------------------------
    def xml_pickle(self):
        '''
        xml_pickle creates xml file from pickle knowledgebase
        '''
       
        
        # -----------------------------------------------------------------------------------------
        # pickle knowledge to xml
        # -----------------------------------------------------------------------------------------        
        
        class2print = 'Pickle4Xi'
        method2print = 'xml_pickle'
            
        xml_pickle4xi()
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
    #</methodize4xi> 
    
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
  
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of pickle4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



